#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                    PhantomDeviance_Advisor_1.mq4 |
//| programmed by Angelo Cavalca                                     |
//|                                                                  |
//|                                        Converted by Mql2Mq4 v0.7 |
//|                                            http://yousky.free.fr |
//|                                    Copyright  2006, Yousky Soft |
//+------------------------------------------------------------------+

#property copyright " Copyright c 2006, "
#property link      " http://www.futuritraders.com"


//+------------------------------------------------------------------+
//| Common External variables                                        |
//+------------------------------------------------------------------+
extern double Lots = 0.10;
extern double StopLoss = 50.00;
extern double TakeProfit = 80.00;
extern double TrailingStop = 0.00;

//+------------------------------------------------------------------+
//| External variables                                               |
//+------------------------------------------------------------------+
extern double MaxDeviance = 32;
extern double MinDeviance = 3;
extern double LookBackPeriod = 12;

//+------------------------------------------------------------------+
//| Special Convertion Functions                                     |
//+------------------------------------------------------------------+

int LastTradeTime;

int MOrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
{
  LastTradeTime = CurTime();
  price = MathRound(price*10000)/10000;
  stoploss = MathRound(stoploss*10000)/10000;
  takeprofit = MathRound(takeprofit*10000)/10000;
  return ( OrderSend( symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color ) );
}

int OrderValueTicket(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderTicket());
}

int OrderValueType(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderType());
}

double OrderValueLots(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderLots());
}

string OrderValueSymbol(int index)
{
  OrderSelect(index, SELECT_BY_POS);
  return(OrderSymbol());
}

void SetArrow(datetime ArrowTime, double Price, double ArrowCode, color ArrowColor)
{
 int err;
 string ArrowName = DoubleToStr(ArrowTime,0);
   if (ObjectFind(ArrowName) != -1) ObjectDelete(ArrowName);
   if(!ObjectCreate(ArrowName, OBJ_ARROW, 0, ArrowTime, Price))
    {
      err=GetLastError();
      Print("error: can't create Arrow! code #",err," ",ErrorDescription(err));
      return;
    }
   else
   {
     ObjectSet(ArrowName, OBJPROP_ARROWCODE, ArrowCode);
     ObjectSet(ArrowName, OBJPROP_COLOR , ArrowColor);
     ObjectsRedraw();
   }
}

//+------------------------------------------------------------------+
//| End                                                              |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Initialization                                                   |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int start()
{
//+------------------------------------------------------------------+
//| Local variables                                                  |
//+------------------------------------------------------------------+
int shift = 0;
double lasthigh = -1;
double lastlow = -1;
double lasthighpos = 0;
double lastlowpos = 0;
double val = 0;
double back = 0;
double res = 0;
double curlow = 0;
double curhigh = 0;
double ax_1 = 0;
double ax_2 = 0;
double Valore_1 = 0;
double Valore_2 = 0;
int Cnt = 0;
double CurHour = -1;
double TradesMade = 0;
double orders = 0;
double lotsi = 0;
double i = 0;
double RefPrev = 0;
double Close_Buy = 0;
double Close_Sell = 0;
double t0 = 0;

/*[[
        Name := Angelo
        Author := Copyright c 2006, 
        Link := http://www.futuritraders.com
        Notes := programmed by Angelo Cavalca 
        Lots := 0.1
        Stop Loss := 50
        Take Profit := 80
        Trailing Stop := 0
]]*/



















lasthigh = -1;
lastlow = -1;
t0 = StrToTime("2005.12.31 0:00");
//if curtime<=t0 then exit //Begin
for(shift =Bars - 300;shift >=0;shift --) {
   //Valore_1=0;
   val = Low[Lowest(NULL, 0, 1,shift + MaxDeviance - 1,MaxDeviance)];
   if( val ==  lastlow ) val = 0 ; else 
      {
      lastlow = val;
      if( Low[shift] - val > MinDeviance * Point ) val = 0 ;
         }
if( val>0 ) ax_1=shift;

// if val>0 then Print("val_1 ", TimeToStr(time)," val:  ",val);

 //Valore_2=0;
   val = High[Highest(NULL, 0, 2,shift + MaxDeviance - 1,MaxDeviance)];
   if( val ==  lasthigh ) val = 0 ; else 
      {
      lasthigh = val;
      if( val - High[shift] > MinDeviance * Point ) val = 0; 
       }
  //if val>0 then Print(shift);
    if( val>0 ) ax_2=shift;
   }

Valore_1=ax_1;
Valore_2=ax_2;
Comment("val: Long ", Valore_1,"     Sell ", Valore_2);
//Print ("val: Long ", Valore_1,"     Sell ", Valore_2);



orders=0;
	for(Cnt=1;Cnt<=OrdersTotal();Cnt++) {
		if( OrderValueSymbol(Cnt) == Symbol() ) {
			orders++;
		}
	}

//if orders==0 and Valore_2==0 and Valore_1>0 then Alert("nui");




if( Minute() ==  59 || Minute() == 29 || Minute() != 0 ) {
if( orders == 0 && Valore_1 == 1 && Valore_2>2 ) {
//if orders==0 and Valore_2 > Valore_1 then {
     SetArrow(Time[0],High[0]+5*Point, 241, Yellow);
      // SetOrder(operation,lots,price,slippage,stoploss,takeprofit,color)
       MOrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Lime);
}
}



if( Minute() ==  59 || Minute() == 29 || Minute() != 0 ) {
if( orders == 0 && Valore_2 == 1 && Valore_1>2 ) {
//if orders==0 and Valore_1 > Valore_2 then {
       SetArrow(Time[0],High[0]+5*Point, 242, Yellow);
      // SetOrder(operation,lots,price,slippage,stoploss,takeprofit,color)
       MOrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",16384,0,Lime);
}
}

Close_Buy=0;
Close_Sell=0;
//if Minute== 59 or Minute=29 then {
//if Valore_2==0 and Valore_1>0 then Close_Buy=1;
//if Valore_1==0 and Valore_2>0 then Close_Sell=1;
if( Valore_2>=1 && Valore_1>Valore_2 ) Close_Buy=1;
if( Valore_1>=1 && Valore_2>Valore_1 ) Close_Sell=1;
//};

for(Cnt=1;Cnt<=OrdersTotal();Cnt++)
{
if( OrderValueSymbol( Cnt) == Symbol() ) {
if( OrderValueType( Cnt) == OP_BUY &&  Close_Buy == 1 ) {
OrderClose(OrderValueTicket( Cnt),OrderValueLots( Cnt),Ask,3,Green);
return(0);
} 
if( OrderValueType( Cnt) == OP_SELL &&  Close_Sell == 1 ) {
OrderClose(OrderValueTicket( Cnt),OrderValueLots( Cnt),Bid,3,Green);
return(0);
} 

} 
}  return(0);
}